require 'sketchup.rb'

def create_cab
  
prompts = ["Cabinet Name", "Cabinet Width", "Cabinet Height", "Cabinet Depth", "Material Thickness   ", "Shelves", "Drawers"]
values = ["", 24.inch, 30.inch, 2.feet, 0.625.inch, 0, 0]
results = inputbox prompts, values, "Bottom Cabinet Dimensions"
@val1, width, height, depth, thick = results
#width, height, depth, thick, @val2 = results
  
model = Sketchup.active_model
ent = Sketchup.active_model.entities
definitions = model.definitions

#Variables
    
    x = 0.25
    x1 = 0.125
    y = depth-0.25
    z = 0.625  

#Create Side Panel

      #Create component definition
      def_side_panel = model.definitions.add("Side Panel")
  
      # Add entities to the component definition
      entities = def_side_panel.entities
      side_panel = entities.add_face [0, 0, 0], [0, y, 0], [0, y, height-z], [0, 0, height-z]
  
      #if blue face is pointing up, reverse it
      def_side_panel! if(side_panel.normal.x<0)
  
      #push/pull
      side_panel.pushpull thick
  
#Create Back Panel

      def_back_panel = model.definitions.add("Back Panel")
  
      entities = def_back_panel.entities
      back_panel = entities.add_face [0, 0, 0], [0, thick, 0], [0, thick, height-z], [0, 0, height-z]
  
      def_back_panel! if(back_panel.normal.x<0)
      back_panel.pushpull width-thick*2
  
#Create Bottom Panel

      def_btm_panel = model.definitions.add("Bottom Panel")
  
      entities = def_btm_panel.entities
      btm_panel = entities.add_face [0, 0, 0], [0, y, 0], [0, y, thick], [0, 0, thick]
  
      def_btm_panel! if(btm_panel.normal.x<0)
      btm_panel.pushpull width

#Create Top Support

      def_top_panel = model.definitions.add("Top Support")
 
      entities = def_top_panel.entities
      top_panel = entities.add_face [0, 0, 0], [0, 2.875, 0], [0, 2.875, thick], [0, 0, thick]
 
      def_top_panel! if(top_panel.normal.x<0)
      top_panel.pushpull width-thick*2
      
# Create Trims

      # Create Side Trims
      def_trim_side = model.definitions.add("Side Trim")
      
      entities = def_trim_side.entities
      trim_side = entities.add_face [0, 0, 0], [0, 0, height], [thick, 0, height], [thick, 0, 0]
      
      def_trim_side! if(trim_side.normal.y<0)
      trim_side.pushpull x
      
      #Create Top and Bottom Trims
      def_trim_tb = model.definitions.add("Top and Bottom Trim")
      
      entities = def_trim_tb.entities
      trim_tb = entities.add_face [0, 0, 0], [0, 0, thick], [width-thick*2, 0, thick], [width-thick*2, 0, 0]
      
      def_trim_tb! if(trim_tb.normal.y<0)
      trim_tb.pushpull x
      
# Create Shelf
  
      def_shelf = model.definitions.add("Shelf")
      
      entities = def_shelf.entities
      shelf = entities.add_face [0, 0, 0], [0, depth-x-thick, 0], [0, depth-x-thick, 0.625], [0, 0, thick]
      
      def_shelf! if(shelf.normal.x<0)
      shelf.pushpull width-thick*2-x

# Refresh Component Thumbnails    

      cdefs = Sketchup.active_model.definitions
      cdefs.each {|comp| comp.refresh_thumbnail }       

# Create Global Cabinet Component

      def_cabinet = model.definitions.add(@val1)
  
      entities = def_cabinet.entities
      cabinet = entities.add_instance def_side_panel, [0, 1, thick]
      cabinet = entities.add_instance def_side_panel, [width-thick, 1, thick]
      cabinet = entities.add_instance def_back_panel, [thick, depth+0.75-thick, thick]
      cabinet = entities.add_instance def_btm_panel, [0, 1, 0]
      cabinet = entities.add_instance def_top_panel, [thick, depth+0.75-thick-2.875, height-z]
      cabinet = entities.add_instance def_top_panel, [thick, 1, height-z]
      cabinet = entities.add_instance def_trim_side, [0, 0.75, 0]
      cabinet = entities.add_instance def_trim_side, [width-thick, 0.75, thick-z]
      cabinet = entities.add_instance def_trim_tb, [thick, 0.75, height-z]
      cabinet = entities.add_instance def_trim_tb, [thick, 0.75, 0]

# Refresh Component Thumbnails

      cdefs = Sketchup.active_model.definitions
      cdefs.each {|comp| comp.refresh_thumbnail }

# Inserts Component on Left Click in Model

      status=model.place_component(def_cabinet)

end

if( not file_loaded?("test.rb") )
    add_separator_to_menu("Plugins")
    UI.menu("Plugins").add_item("test") { create_cab }
    
end

file_loaded("test.rb")